%define api 5
%define major 5
%define oname qt5

%define module qttools

%define qtclucene %mklibname qt%{api}clucene %{major}
%define qtclucened %mklibname qt%{api}clucene -d
%define qtdesigner %mklibname qt%{api}designer %{major}
%define qtdesignerd %mklibname qt%{api}designer -d
%define qtdesignercomponents %mklibname qt%{api}designercomponents %{major}
%define qtdesignercomponentsd %mklibname qt%{api}designercomponents -d
%define qthelp %mklibname qt%{api}help %{major}
%define qthelpd %mklibname qt%{api}help -d
%define qtuitoolsd %mklibname qt%{api}uitools -d

# Requires qdoc5 and qt5-tools to build
%bcond_with docs

Summary:	Version 5 of the Qt toolkit (%{module} packages)
Name:		qt5-%{module}
Version:	5.6.1
Release:	1
License:	LGPLv3+
Group:		Development/KDE and Qt
Url:		http://qt-project.org/
Source0:	http://ftp.fau.de/qtproject/official_releases/qt/%(echo %{version} |cut -d. -f1-2)/%{version}/submodules/%{module}-opensource-src-%{version}.tar.xz
Source1:	rosa-assistant-qt%{api}.desktop
Source2:	rosa-designer-qt%{api}.desktop
Source3:	rosa-linguist-qt%{api}.desktop
# Install pkgconfig file for Clucene because it's used by other projects
Patch0:		qttools-opensource-src-5.6.1-clucene-pkgconfig.patch
# Same for Designer Components, needed for Qt Creator
Patch1:		qttools-opensource-src-5.6.1-designer-components-pkgconfig.patch
Source100:	%{name}.rpmlintrc
BuildRequires:	pkgconfig(Qt5Core) >= %{version}
BuildRequires:	pkgconfig(Qt5DBus) >= %{version}
BuildRequires:	pkgconfig(Qt5Gui) >= %{version}
BuildRequires:	pkgconfig(Qt5Network) >= %{version}
BuildRequires:	pkgconfig(Qt5PrintSupport) >= %{version}
BuildRequires:	pkgconfig(Qt5Qml) >= %{version}
BuildRequires:	pkgconfig(Qt5Quick) >= %{version}
BuildRequires:	pkgconfig(Qt5Sql) >= %{version}
BuildRequires:	pkgconfig(Qt5Test) >= %{version}
BuildRequires:	pkgconfig(Qt5Widgets) >= %{version}
BuildRequires:	pkgconfig(Qt5Xml) >= %{version}
%if %{with docs}
BuildRequires:	qdoc5
BuildRequires:	qt5-tools
%endif

%description
Version 5 of the Qt toolkit (%{module} packages).

#----------------------------------------------------------------------------

%package -n %{qtclucene}
Summary:	Qt version of the CLucene search engine
Group:		System/Libraries

%description -n %{qtclucene}
Qt version of the CLucene search engine.

%files -n %{qtclucene}
%{_qt5_libdir}/libQt%{api}CLucene.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}CLucene.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtclucened}
Summary:	Development files for the Qt version of the CLucene search engine
Group:		Development/KDE and Qt
Requires:	%{qtclucene} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtclucened}
Development files for the Qt version of the CLucene search engine.

%files -n %{qtclucened}
%{_qt5_includedir}/QtCLucene
%{_qt5_libdir}/libQt%{api}CLucene.so
%{_qt5_libdir}/libQt%{api}CLucene.prl
%{_qt5_libdir}/cmake/Qt%{api}CLucene
%{_qt5_libdir}/pkgconfig/Qt%{api}CLucene.pc
%{_qt5_prefix}/mkspecs/modules/qt_lib_clucene.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_clucene_private.pri

#----------------------------------------------------------------------------

%package -n %{qtdesigner}
Summary:	Qt Designer runtime libraries
Group:		System/Libraries

%description -n %{qtdesigner}
Qt Designer runtime libraries.

%files -n %{qtdesigner}
%{_qt5_libdir}/libQt%{api}Designer.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Designer.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtdesignerd}
Summary:	Development files for Qt Designer
Group:		Development/KDE and Qt
Requires:	%{qtdesigner} = %{EVRD}
Requires:	qmake%{api}
# cmake module needs its files
Requires:	qt5-designer
Requires:	%{qtuitoolsd} = %{EVRD}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtdesignerd}
Development files for Qt Designer.

%files -n %{qtdesignerd}
%{_qt5_includedir}/QtDesigner
%{_qt5_libdir}/libQt%{api}Designer.so
%{_qt5_libdir}/libQt%{api}Designer.prl
%{_qt5_libdir}/cmake/Qt%{api}Designer
%{_qt5_libdir}/pkgconfig/Qt%{api}Designer.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Designer.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_designer.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_designer_private.pri

#----------------------------------------------------------------------------

%package -n %{qtdesignercomponents}
Summary:	Components for Qt Designer
Group:		System/Libraries

%description -n %{qtdesignercomponents}
Components for Qt Designer.

%files -n %{qtdesignercomponents}
%{_qt5_libdir}/libQt%{api}DesignerComponents.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}DesignerComponents.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtdesignercomponentsd}
Summary:	Development files for Qt Designer Components
Group:		Development/KDE and Qt
Requires:	%{qtdesignercomponents} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtdesignercomponentsd}
Development files for Qt Designer Components.

%files -n %{qtdesignercomponentsd}
%{_qt5_includedir}/QtDesignerComponents
%{_qt5_libdir}/libQt%{api}DesignerComponents.so
%{_qt5_libdir}/libQt%{api}DesignerComponents.prl
%{_qt5_libdir}/cmake/Qt%{api}DesignerComponents
%{_qt5_libdir}/pkgconfig/Qt%{api}DesignerComponents.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}DesignerComponents.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_designercomponents.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_designercomponents_private.pri

#----------------------------------------------------------------------------

%package -n %{qthelp}
Summary:	Runtime libraries for the Qt Help system
Group:		System/Libraries

%description -n %{qthelp}
Runtime libraries for the Qt Help system.

%files -n %{qthelp}
%{_qt5_libdir}/libQt%{api}Help.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Help.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qthelpd}
Summary:	Development files for Qt Help
Group:		Development/KDE and Qt
Requires:	%{qthelp} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qthelpd}
Development files for Qt Help, useful if you wish to add a help system
to your application.

%files -n %{qthelpd}
%{_qt5_includedir}/QtHelp
%{_qt5_libdir}/libQt%{api}Help.so
%{_qt5_libdir}/libQt%{api}Help.prl
%{_qt5_libdir}/cmake/Qt%{api}Help
%{_qt5_libdir}/pkgconfig/Qt%{api}Help.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Help.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_help.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_help_private.pri

#----------------------------------------------------------------------------

%package -n %{qtuitoolsd}
Summary:	Development files for Qt Ui Tools
Group:		Development/KDE and Qt
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0
Conflicts:	%{_lib}qt5gui-devel < 5.6.0

%description -n %{qtuitoolsd}
Development files for Qt Ui Tools.

%files -n %{qtuitoolsd}
%{_qt5_includedir}/QtUiPlugin
%{_qt5_includedir}/QtUiTools
%{_qt5_libdir}/libQt%{api}UiTools.a
%{_qt5_libdir}/libQt%{api}UiTools.prl
%{_qt5_libdir}/cmake/Qt%{api}UiPlugin
%{_qt5_libdir}/cmake/Qt%{api}UiTools
%{_qt5_libdir}/pkgconfig/Qt%{api}UiTools.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}UiTools.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_uiplugin.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_uitools.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_uitools_private.pri

#----------------------------------------------------------------------------

%package -n %{oname}-assistant
Summary:	Qt help system
Group:		Development/KDE and Qt
Suggests:	qt5-assistant-i18n
Suggests:	qt5-doc

%description -n %{oname}-assistant
Qt help system.

%files -n %{oname}-assistant
%{_qt5_bindir}/assistant
%{_datadir}/applications/rosa-assistant-qt%{api}.desktop

#----------------------------------------------------------------------------

%package -n %{oname}-designer
Summary:	Qt interface design tool
Group:		Development/KDE and Qt
# Should be X11 later
Requires:	qt5-output-driver-default
# for /usr/lib/qt5/bin/uic
Requires:	pkgconfig(Qt5Gui)
Suggests:	qt5-designer-i18n

%description -n %{oname}-designer
Qt interface design tool.

%files -n %{oname}-designer
%{_qt5_bindir}/designer
%{_datadir}/applications/rosa-designer-qt%{api}.desktop
%{_qt5_plugindir}/designer

#----------------------------------------------------------------------------

%package -n %{oname}-linguist
Summary:	Translation tool for Qt based applications
Group:		Development/KDE and Qt
Requires:	%{oname}-linguist-tools = %{EVRD}
Suggests:	qt5-linguist-i18n

%description -n %{oname}-linguist
Translation tool for Qt based applications.

%files -n %{oname}-linguist
%{_qt5_bindir}/linguist
%{_datadir}/applications/rosa-linguist-qt%{api}.desktop
%dir %{_qt5_datadir}/phrasebooks
%lang(da) %{_qt5_datadir}/phrasebooks/danish.qph
%lang(nl) %{_qt5_datadir}/phrasebooks/dutch.qph
%lang(fi) %{_qt5_datadir}/phrasebooks/finnish.qph
%lang(fr) %{_qt5_datadir}/phrasebooks/french.qph
%lang(de) %{_qt5_datadir}/phrasebooks/german.qph
%lang(hu) %{_qt5_datadir}/phrasebooks/hungarian.qph
%lang(it) %{_qt5_datadir}/phrasebooks/italian.qph
%lang(ja) %{_qt5_datadir}/phrasebooks/japanese.qph
%lang(no) %{_qt5_datadir}/phrasebooks/norwegian.qph
%lang(pl) %{_qt5_datadir}/phrasebooks/polish.qph
%lang(ru) %{_qt5_datadir}/phrasebooks/russian.qph
%lang(es) %{_qt5_datadir}/phrasebooks/spanish.qph
%lang(sv) %{_qt5_datadir}/phrasebooks/swedish.qph

#----------------------------------------------------------------------------

%package -n %{oname}-linguist-tools
Summary:	Tools for creating and updating Qt Linguist translation files
Group:		Development/KDE and Qt

%description -n %{oname}-linguist-tools
Tools for creating and updating Qt Linguist translation files.

%files -n %{oname}-linguist-tools
%{_qt5_bindir}/lconvert
%{_qt5_bindir}/lrelease
%{_qt5_bindir}/lupdate
%{_bindir}/lconvert-qt%{api}
%{_bindir}/lrelease-qt%{api}
%{_bindir}/lupdate-qt%{api}
%{_qt5_libdir}/cmake/Qt%{api}LinguistTools

#----------------------------------------------------------------------------

%package -n %{oname}-tools
Summary:	Tools for Qt 5
Group:		Development/KDE and Qt
# Should be fixed later
# Requires:	qt5-output-driver-minimal
Requires:	%{_lib}qt5gui5-minimal
Requires:	qt5-database-plugin-sqlite

%description -n %{oname}-tools
Tools for Qt 5.

%files -n %{oname}-tools
%{_bindir}/qdbus-qt%{api}
%{_bindir}/qtpaths-qt%{api}
%{_qt5_bindir}/pixeltool
%{_qt5_bindir}/qcollectiongenerator
%{_qt5_bindir}/qdbus
%{_qt5_bindir}/qdbusviewer
%{_qt5_bindir}/qhelpconverter
%{_qt5_bindir}/qhelpgenerator
%{_qt5_bindir}/qtdiag
%{_qt5_bindir}/qtpaths
%{_qt5_bindir}/qtplugininfo

#----------------------------------------------------------------------------

%package -n qdoc%{api}
Summary:	Qt documentation generator, version 5
Group:		Development/KDE and Qt

%description -n qdoc%{api}
Qt documentation generator, version 5.

%files -n qdoc%{api}
%{_qt5_bindir}/qdoc

#----------------------------------------------------------------------------

%package examples
Summary:	Example applications for %{name}
Group:		Development/KDE and Qt
Conflicts:	qt5-examples < 5.6.0

%description examples
Example applications for %{name}.

%files examples
%{_qt5_exampledir}/assistant/
%{_qt5_exampledir}/designer/
%{_qt5_exampledir}/help/
%{_qt5_exampledir}/linguist/
%{_qt5_exampledir}/uitools/

#----------------------------------------------------------------------------

%prep
%setup -qn %{module}-opensource-src-%{version}
%patch0 -p1
%patch1 -p1

%build
%qmake_qt5
%make STRIP=true

%if %{with docs}
%make docs
%endif

%install
%makeinstall_qt

%if %{with docs}
make install_qch_docs INSTALL_ROOT=%{buildroot}
%endif

# Let's make life easier for packagers
mkdir -p %{buildroot}%{_bindir}
for i in lrelease lupdate lconvert qdbus qtpaths; do
    ln -s ../%{_lib}/qt%{api}/bin/$i %{buildroot}%{_bindir}/$i-qt%{api}
done

%if "%{_qt5_libdir}" != "%{_libdir}"
pushd %{buildroot}%{_libdir}
ln -s ../%{_lib}/qt%{api}/%{_lib}/*.so.* .
mkdir pkgconfig
cd pkgconfig
ln -s ../../%{_lib}/qt%{api}/%{_lib}/pkgconfig/*.pc .
popd
%endif

# Workaround for
# *** ERROR: same build ID in nonidentical files!
#        /usr/lib/qt5/bin/qdbuscpp2xml
#   and  /usr/lib/qt5/bin/moc
# ...
# while generating debug info
find %{buildroot} -type f -perm -0755 |grep -vE '\.(so|qml|sh|pl|ttf|eot|woff)' |xargs %__strip --strip-unneeded

# Install .desktop files for assistant, designer and linguist
mkdir -p %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE3} %{buildroot}%{_datadir}/applications

sed -i s,"/usr/lib/qt5/bin","%{_qt5_bindir}",g %{buildroot}%{_datadir}/applications/*.desktop

# QMAKE_PRL_BUILD_DIR = /builddir/build/BUILD/qt-everywhere-opensource-src-5.4.0-beta/qtwayland/src/client
## .prl/.la file love
# nuke .prl reference(s) to %%buildroot, excessive (.la-like) libs
pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd

%changelog

* Sun Jun 12 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 5.6.1-1
- (7ef0d2a) Re-diff pkgconfig patches


